## rtpengine 10.5.1.3

=== Makefile ===
RTPENGINE_ROOT_DIR=.
with_transcoding ?= yes

ifeq ($(DO_ASAN_FLAGS),1)
ASAN_FLAGS = -ggdb -O0 -fsanitize=address -fsanitize=leak -fsanitize=undefined
CFLAGS ?= -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
CFLAGS += $(ASAN_FLAGS)
LDFLAGS += $(ASAN_FLAGS)
export CFLAGS
export LDFLAGS
export ASAN_OPTIONS=verify_asan_link_order=0
export UBSAN_OPTIONS=print_stacktrace=1
export G_SLICE=always-malloc
endif

include lib/lib.Makefile

.PHONY:	all distclean clean coverity

all:
	$(MAKE) -C daemon
ifeq ($(with_transcoding),yes)
	$(MAKE) -C recording-daemon
endif
	$(MAKE) -C iptables-extension

coverity:
	$(MAKE) -C daemon
ifeq ($(with_transcoding),yes)
	$(MAKE) -C recording-daemon
endif

.PHONY: with-kernel

with-kernel: all
	$(MAKE) -C kernel-module

distclean clean:
	$(MAKE) -C daemon clean
	$(MAKE) -C recording-daemon clean
	$(MAKE) -C iptables-extension clean
	$(MAKE) -C kernel-module clean
	$(MAKE) -C t clean

.DEFAULT:
	$(MAKE) -C daemon $@
	$(MAKE) -C recording-daemon $@
	$(MAKE) -C iptables-extension $@
	$(MAKE) -C kernel-module $@

.PHONY: check asan-check

check: all
	$(MAKE) -C t

asan-check:
	DO_ASAN_FLAGS=1 $(MAKE) check

=== debian/changelog ===
rtpengine (10.5.1.3-1build2) kinetic; urgency=medium

  * No-change rebuild against libevent-2.1-7a (LP: #1990941)

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 07 Oct 2022 19:58:05 +0200

rtpengine (10.5.1.3-1build1) kinetic; urgency=medium

  * No-change rebuild against libwebsockets17

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 20 Aug 2022 18:04:00 +0000

rtpengine (10.5.1.3-1) unstable; urgency=medium

  [ Guillem Jover ]
  * Switch to debhelper compatibility level 13
  * Fix arch:all-only package builds
  * Remove unnecessary override_dh_dwz with newer dwz
  * Switch to execute_before/after_ instead of override_

  [ Victor Seva ]
  * New upstream version 10.5.1.3
  * manage /var/spool/rtpengine in rtpengine-daemon

 -- Victor Seva <vseva@debian.org>  Thu, 21 Jul 2022 18:35:14 +0200

rtpengine (10.4.1.6-1) unstable; urgency=medium

  [ Guillem Jover ]
  * Use my Sipwise hat in Uploaders
  * Reorder debian/control fields

  [ Victor Seva ]
  * New upstream version 10.4.1.6 (Closes: #1012766)

 -- Victor Seva <vseva@debian.org>  Thu, 16 Jun 2022 21:27:50 +0200

rtpengine (10.4.1.3-1) unstable; urgency=medium

  * Initial release. (Closes: #916126)

 -- Victor Seva <vseva@debian.org>  Tue, 17 May 2022 10:01:19 +0200

=== debian/control ===
Source: rtpengine
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Victor Seva <vseva@debian.org>,
 Guillem Jover <gjover@sipwise.com>,
 Michael Prokop <mika@debian.org>,
Homepage: https://github.com/sipwise/rtpengine/
Standards-Version: 4.6.1
Build-Depends:
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 gperf,
 libavcodec-dev (>= 6:10),
 libavfilter-dev (>= 6:10),
 libavformat-dev (>= 6:10),
 libavutil-dev (>= 6:10),
 libbcg729-dev <!pkg.rtpengine.nobcg729>,
 libbencode-perl,
 libcrypt-openssl-rsa-perl,
 libcrypt-rijndael-perl,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 libdigest-crc-perl,
 libdigest-hmac-perl,
 libevent-dev (>= 2.0),
 libglib2.0-dev (>= 2.30),
 libhiredis-dev,
 libio-multiplex-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libiptc-dev,
 libjson-glib-dev,
 libjson-perl,
 libmosquitto-dev,
 libnet-interface-perl,
 libpcap0.8-dev,
 libpcre3-dev,
 libsocket6-perl,
 libspandsp-dev,
 libssl-dev (>= 1.0.1),
 libswresample-dev (>= 6:10),
 libsystemd-dev,
 libwebsockets-dev,
 libxmlrpc-core-c3-dev (>= 1.16.07),
 libxtables-dev (>= 1.4) | iptables-dev (>= 1.4),
 markdown,
 python3,
 python3-websockets,
 zlib1g-dev,

Package: rtpengine-daemon
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 iptables,
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 rtpengine-recording-daemon,
 rtpengine-utils,
Conflicts:
 ngcp-rtpengine-daemon,
Description: proxy for RTP and media streams used in NGCP, userspace part
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This daemon handles the first stages of proxying media streams and talks to
 the kernel part of the proxy for eventual high-performance packet forwarding.

Package: rtpengine-recording-daemon
Architecture: any
Multi-Arch: foreign
Build-Profiles: <!pkg.rtpengine.no-transcoding>
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 lsb-base (>= 3.0-6),
 nfs-common,
 rtpengine-daemon,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 rtpengine-utils,
Conflicts:
 ngcp-rtpengine-recording-daemon,
Description: recording daemon for RTP and media streams
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This daemon handles the call recording (media intercept) component of rtpengine.

Package: rtpengine-iptables
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 ngcp-rtpengine-iptables,
Description: IPtables extension module for the kernel-space NGCP media proxy
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 Provides the IPtables extension needed to configure the mediaproxy rule.

Package: rtpengine
Architecture: all
Multi-Arch: foreign
Depends:
 rtpengine-daemon (>= ${source:Version}),
 rtpengine-iptables (>= ${source:Version}),
 rtpengine-kernel-dkms (>= ${source:Version}),
 rtpengine-recording-daemon (>= ${source:Version}),
 rtpengine-utils (>= ${source:Version}),
 ${misc:Depends},
Conflicts:
 ngcp-rtpengine,
Description: NGCP RTP/media proxy - metapackage
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This is a metapackage for easy installation of all four parts of the NGCP
 media proxy. It will install the user-space daemon, the kernel-space IPtables
 module, the IPtables extension module and utility scripts.

Package: rtpengine-kernel-dkms
Section: kernel
Architecture: all
Depends:
 dkms (>= 1.95),
 lsb-release,
 ${misc:Depends},
Conflicts:
 ngcp-rtpengine-kernel-dkms,
Description: IPtables kernel module for the NGCP media proxy - DKMS
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 Provides the kernel-space part of the NGCP media proxy for high-
 performance packet forwarding.
 This package contains the source to be built with dkms.

Package: rtpengine-utils
Architecture: all
Multi-Arch: foreign
Depends:
 libbencode-perl,
 libconfig-tiny-perl,
 libcrypt-rijndael-perl,
 libdigest-hmac-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libsocket6-perl,
 netcat-openbsd | netcat,
 ${misc:Depends},
 ${perl:Depends},
Conflicts:
 ngcp-rtpengine-utils,
Description: scripts and Perl modules for NGCP rtpengine
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This package contains scripts and Perl modules for NGCP rtpengine

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

## kernel package specific stuff
# Name of the dkms package
pdkms:=rtpengine-kernel-dkms
# short upstream name, used for module source directory
sname:=rtpengine
# Source version
sversion:=$(DEB_VERSION_UPSTREAM)
## end of kernel package specific stuff

export XTABLES_DIR := $(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)

ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.no-transcoding))
export with_transcoding = no
endif
ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.asan))
export DO_ASAN_FLAGS = 1
# this prevents dh from setting default (including -O2) which we don't want
export DEB_CFLAGS_MAINT_SET =
export DEB_LDFLAGS_MAINT_SET =
endif

%:
	dh $@

execute_before_dh_auto_install-indep:
	# Create the directories to install the source into
	dh_installdirs -p$(pdkms)    usr/src/$(sname)-$(sversion)

	# Copy only the driver source to the proper locations
	cd kernel-module && cp Makefile *.c *.h ../debian/$(pdkms)/usr/src/$(sname)-$(sversion)

	# Prepare dkms.conf from the dkms.conf.in template
	sed "s/__VERSION__/$(sversion)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(sname)-$(sversion)/dkms.conf

	# markdown README
	markdown README.md | gzip -9 > debian/README.html.gz
	gzip -9 < README.md > debian/README.md.gz

execute_after_dh_installsystemd:
	dh_installsystemd -prtpengine-recording-daemon --name=rtpengine-recording-nfs-mount

=== debian/watch ===
version=4
https://github.com/sipwise/rtpengine/tags (?:.*?/)?mr(\d[\d.]*)\.tar\.gz

## rtpengine 10.5.2.9

=== debian/changelog ===
rtpengine (10.5.2.9-1) unstable; urgency=medium

  * New upstream version 10.5.2.9 (Closes: #1018735)
  * Stop recording timestamps when gzip'ing files

 -- Victor Seva <vseva@debian.org>  Wed, 14 Dec 2022 20:59:40 +0100

rtpengine (10.5.2.6-1) unstable; urgency=medium

  * debian/watch: just follow the LTS version line for now
  * New upstream version 10.5.2.6

 -- Victor Seva <vseva@debian.org>  Wed, 26 Oct 2022 00:03:50 +0200

rtpengine (10.5.2.4-1) unstable; urgency=medium

  * New upstream version 10.5.2.4

 -- Victor Seva <vseva@debian.org>  Mon, 03 Oct 2022 09:16:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: rtpengine
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders:
  Victor Seva <vseva@debian.org>,
  Guillem Jover <gjover@sipwise.com>,

=== debian/rules ===
--- 
+++ 
@@ -41,8 +41,8 @@
 	sed "s/__VERSION__/$(sversion)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(sname)-$(sversion)/dkms.conf
 
 	# markdown README
-	markdown README.md | gzip -9 > debian/README.html.gz
-	gzip -9 < README.md > debian/README.md.gz
+	markdown README.md | gzip -9n > debian/README.html.gz
+	gzip -9n < README.md > debian/README.md.gz
 
 execute_after_dh_installsystemd:
 	dh_installsystemd -prtpengine-recording-daemon --name=rtpengine-recording-nfs-mount

## rtpengine 10.5.3.5

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,7 @@
 ASAN_FLAGS = -ggdb -O0 -fsanitize=address -fsanitize=leak -fsanitize=undefined
 CFLAGS ?= -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
 CFLAGS += $(ASAN_FLAGS)
+CFLAGS += -DASAN_BUILD
 LDFLAGS += $(ASAN_FLAGS)
 export CFLAGS
 export LDFLAGS

=== daemon/Makefile ===
TARGET=		rtpengine

with_iptables_option ?= yes
with_transcoding ?= yes


CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
CFLAGS+=	-pthread -fno-strict-aliasing
CFLAGS+=	-std=c99
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	$(shell pkg-config --cflags libpcre)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
ifeq ($(with_iptables_option),yes)
CFLAGS+=	$(shell pkg-config --cflags libiptc)
CFLAGS+=	-DWITH_IPTABLES_OPTION
endif
CFLAGS+=	-I. -I../kernel-module/ -I../lib/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=        $(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

### compile time options:
#CFLAGS+=	-DSRTCP_KEY_DERIVATION_RFC_COMPLIANCE
#CFLAGS+=	-DSTRICT_SDES_KEY_LIFETIME

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs libpcre)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
LDLIBS+=	$(shell pkg-config --libs libwebsockets)
ifeq ($(with_iptables_option),yes)
LDLIBS+=	$(shell pkg-config --libs libiptc)
endif
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=        $(shell mysql_config --libs)
endif

ifeq ($(with_transcoding),yes)
include ../lib/g729.Makefile
endif

include ../lib/mqtt.Makefile

SRCS=		main.c kernel.c poller.c aux.c control_tcp.c call.c control_udp.c redis.c \
		bencode.c cookie_cache.c udp_listener.c control_ng.strhash.c sdp.strhash.c stun.c rtcp.c \
		crypto.c rtp.c call_interfaces.strhash.c dtls.c log.c cli.c graphite.c ice.c \
		media_socket.c homer.c recording.c statistics.c cdr.c ssrc.c iptables.c tcp_listener.c \
		codec.c load.c dtmf.c timerthread.c media_player.c jitter_buffer.c t38.c websocket.c \
		mqtt.c janus.strhash.c
LIBSRCS=	loglib.c auxlib.c rtplib.c str.c socket.c streambuf.c ssllib.c dtmflib.c
ifeq ($(with_transcoding),yes)
LIBSRCS+=	codeclib.c resample.c
endif
OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o)

PODS=		rtpengine.pod
MANS=		$(PODS:.pod=.8)

include ../lib/common.Makefile

=== iptables-extension/Makefile ===
CC?=gcc
CFLAGS		?= -O2 -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
CFLAGS		+= -shared -fPIC
ifneq ($(RTPENGINE_VERSION),)
  CFLAGS	+= -DRTPENGINE_VERSION="\"$(RTPENGINE_VERSION)\""
else
  DPKG_PRSCHNGLG= $(shell which dpkg-parsechangelog 2>/dev/null)
  ifneq ($(DPKG_PRSCHNGLG),)
    CFLAGS	+= -DRTPENGINE_VERSION="\"$(shell dpkg-parsechangelog -l../debian/changelog | awk '/^Version: / {print $$2}')\""
  else
    CFLAGS	+= -DRTPENGINE_VERSION="\"undefined\""
  endif
endif

XTABLES_INSTALLED=$(shell \
  if pkg-config --exists xtables; then \
    echo 'xtables found'; \
  fi)
ifneq ($(XTABLES_INSTALLED),)
XTABLES = 1
CFLAGS  += $(shell pkg-config --cflags --libs xtables)
else
XTABLES = $(shell test -e /usr/include/xtables.h && echo 1)
endif

IPTABLES	= $(shell test -e /usr/include/iptables.h && echo 1)
IP6TABLES	= $(shell test -e /usr/include/ip6tables.h && echo 1)

WORK=0

.PHONY: all module clean install

all: module

ifeq ($(XTABLES),1)

WORK=1
module: libxt_RTPENGINE.so

libxt_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -o libxt_RTPENGINE.so libxt_RTPENGINE.c

else

ifeq ($(IPTABLES),1)
WORK=1
module: libipt_RTPENGINE.so
endif
ifeq ($(IP6TABLES),1)
WORK=1
module: libip6t_RTPENGINE.so
endif

libipt_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -D__ipt -o libipt_RTPENGINE.so libxt_RTPENGINE.c

libip6t_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -D__ip6t -o libip6t_RTPENGINE.so libxt_RTPENGINE.c

endif

ifeq ($(WORK),0)
module:
	@echo No iptables dev packages installed!
endif

clean:
	rm -f libxt_RTPENGINE.so libipt_RTPENGINE.so libip6t_RTPENGINE.so

install:

=== kernel-module/Makefile ===
PWD    := $(shell pwd)
KSRC   ?= /lib/modules/$(shell uname -r)/build
KBUILD := $(KSRC)
M      ?= $(PWD)

ifeq ($(RTPENGINE_VERSION),)
  DPKG_PRSCHNGLG= $(shell which dpkg-parsechangelog 2>/dev/null)
  DEB_CHANGELOG=$(shell test -f $(M)/../debian/changelog && echo $(M)/../debian/changelog || echo $(M)/debian/changelog)
  ifneq ($(DPKG_PRSCHNGLG),)
    DPKG_PRSCHNGLG=$(shell dpkg-parsechangelog -l$(DEB_CHANGELOG) | awk '/^Version: / {print $$2}')
  endif
  GIT_BR_COMMIT=git-$(shell cd $(M) && git rev-parse --abbrev-ref --symbolic-full-name HEAD 2> /dev/null)-$(shell cd $(M) && git rev-parse --short HEAD 2> /dev/null)

  ifneq ($(DPKG_PRSCHNGLG),)
    RTPENGINE_VERSION+=$(DPKG_PRSCHNGLG)
  endif
  ifneq ($(GIT_BR_COMMIT),git--)
    RTPENGINE_VERSION+=$(GIT_BR_COMMIT)
  endif

  ifeq ($(RTPENGINE_VERSION),)
    RTPENGINE_VERSION+=undefined
  endif
endif
EXTRA_CFLAGS+=	-DRTPENGINE_VERSION="\"$(RTPENGINE_VERSION)\""

EXTRA_CFLAGS += -D__RE_EXTERNAL

obj-m        += xt_RTPENGINE.o

.PHONY:		modules clean patch install

modules:
		$(MAKE) -C $(KBUILD) M=$(PWD) O=$(KBUILD) modules

clean:
		$(MAKE) -C $(KBUILD) M=$(PWD) clean || true

patch:
		../utils/patch-kernel magic "$(PWD)" "$(KERNEL)" "$(RTPENGINE_VERSION)"

install:

=== recording-daemon/Makefile ===
TARGET=		rtpengine-recording

CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
CFLAGS+=	-pthread -I. -I../lib/ -I../kernel-module/
CFLAGS+=	-std=c99 -fno-strict-aliasing
CFLAGS+=	-D_GNU_SOURCE -D_POSIX_SOURCE -D_POSIX_C_SOURCE
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell mysql_config --cflags)
CFLAGS+=	$(shell pkg-config --cflags openssl)

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell mysql_config --libs)
LDLIBS+=	$(shell pkg-config --libs openssl)

include ../lib/g729.Makefile

SRCS=		epoll.c garbage.c inotify.c main.c metafile.c stream.c recaux.c packet.c \
		decoder.c output.c mix.c db.c log.c forward.c tag.c poller.c
LIBSRCS=	loglib.c auxlib.c rtplib.c codeclib.c resample.c str.c socket.c streambuf.c ssllib.c \
		dtmflib.c
OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o)

PODS=		rtpengine-recording.pod
MANS=		$(PODS:.pod=.8)

include ../lib/common.Makefile

=== t/Makefile ===
TARGET=		all-tests

with_transcoding ?= yes

CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
PRELOAD_CFLAGS := $(CFLAGS)
CFLAGS+=	-pthread -fno-strict-aliasing
CFLAGS+=	-std=c99
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	-I. -I../lib/ -I../kernel-module/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
CFLAGS+=	$(shell pkg-config --cflags libpcre)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
ifeq ($(with_amr_tests),yes)
CFLAGS+=	-DWITH_AMR_TESTS
endif
CFLAGS+=	$(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libpcre)
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs libwebsockets)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell mysql_config --libs)
endif

SRCS=		test-bitstr.c aes-crypt.c aead-aes-crypt.c test-const_str_hash.strhash.c
LIBSRCS=	loglib.c auxlib.c str.c rtplib.c ssllib.c
DAEMONSRCS=	crypto.c ssrc.c aux.c rtp.c
HASHSRCS=

ifeq ($(with_transcoding),yes)
SRCS+=		test-transcode.c test-dtmf-detect.c test-payload-tracker.c test-resample.c test-stats.c
SRCS+=		spandsp_recv_fax_pcm.c spandsp_recv_fax_t38.c spandsp_send_fax_pcm.c \
		spandsp_send_fax_t38.c
ifeq ($(with_amr_tests),yes)
SRCS+=		test-amr-decode.c test-amr-encode.c
endif
LIBSRCS+=	codeclib.c resample.c socket.c streambuf.c dtmflib.c
DAEMONSRCS+=	codec.c call.c ice.c kernel.c media_socket.c stun.c bencode.c poller.c \
		dtls.c recording.c statistics.c rtcp.c redis.c iptables.c graphite.c \
		cookie_cache.c udp_listener.c homer.c load.c cdr.c dtmf.c timerthread.c \
		media_player.c jitter_buffer.c t38.c tcp_listener.c mqtt.c websocket.c cli.c
HASHSRCS+=	call_interfaces.c control_ng.c sdp.c janus.c
endif

OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(DAEMONSRCS:.c=.o) $(HASHSRCS:.c=.strhash.o)

COMMONOBJS=	str.o auxlib.o rtplib.o loglib.o ssllib.o

include ../lib/common.Makefile

.PHONY:		all-tests unit-tests daemon-tests daemon-tests \
	daemon-tests-main daemon-tests-jb daemon-tests-dtx daemon-tests-dtx-cn daemon-tests-pubsub \
	daemon-tests-intfs daemon-tests-stats daemon-tests-delay-buffer daemon-tests-delay-timing

TESTS=		test-bitstr aes-crypt aead-aes-crypt test-const_str_hash.strhash
ifeq ($(with_transcoding),yes)
TESTS+=		test-transcode test-dtmf-detect test-payload-tracker test-resample test-stats
ifeq ($(with_amr_tests),yes)
TESTS+=		test-amr-decode test-amr-encode
endif
endif

ADD_CLEAN=	tests-preload.so $(TESTS)

ifeq ($(with_transcoding),yes)
all-tests:	unit-tests daemon-tests
else
all-tests:	unit-tests
endif
	true # override linking recipe from common.Makefile

unit-tests:	$(TESTS)
	failed="" ; \
	for x in $(TESTS); do \
	  echo `date +"%Y-%m-%d %H:%M:%S"` testing: $$x ; \
	  G_DEBUG=fatal-warnings ./$$x ; \
	  if [ $$? -eq 0 ] ; \
	    then echo `date +"%Y-%m-%d %H:%M:%S"` test $$x: succeeded ; \
	    else echo `date +"%Y-%m-%d %H:%M:%S"` test $$x: failed ; failed="$$failed $$x" ; \
	  fi ; \
	done ; \
	if [ -n "$$failed" ] ; then \
	  echo "Tests failed: $$failed" ; \
	  exit 1 ; \
	fi

daemon-tests: daemon-tests-main daemon-tests-jb daemon-tests-pubsub daemon-tests-websocket \
	daemon-tests-intfs daemon-tests-stats # daemon-tests-delay-buffer daemon-tests-delay-timing

daemon-test-deps:	tests-preload.so
	$(MAKE) -C ../daemon

daemon-tests-main:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-jb:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-jb.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-dtx:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-dtx.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-dtx-cn:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-dtx-cn.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-pubsub:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-pubsub.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-stats:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-stats.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-websocket:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   python3 auto-daemon-tests-websocket.py
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-intfs:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-intfs.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-delay-buffer:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-delay-buffer.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-delay-timing:	daemon-test-deps
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-delay-timing.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

test-bitstr:	test-bitstr.o

spandsp_send_fax_pcm:	spandsp_send_fax_pcm.o

spandsp_recv_fax_pcm:	spandsp_recv_fax_pcm.o

spandsp_send_fax_t38:	spandsp_send_fax_t38.o

spandsp_recv_fax_t38:	spandsp_recv_fax_t38.o

spandsp_raw_fax_tests: spandsp_send_fax_pcm spandsp_recv_fax_pcm spandsp_send_fax_t38 spandsp_recv_fax_t38

test-amr-decode: test-amr-decode-test.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-amr-encode: test-amr-encode-test.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-dtmf-detect: test-dtmf-detect.o

aes-crypt:	aes-crypt.o $(COMMONOBJS) crypto.o

aead-aes-crypt:	aead-aes-crypt.o $(COMMONOBJS) crypto.o

test-stats:	test-stats.o $(COMMONOBJS) codeclib.o resample.o codec.o ssrc.o call.o ice.o aux.o \
	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
	control_ng.strhash.o graphite.o \
	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o \
	websocket.o cli.o

test-transcode:	test-transcode.o $(COMMONOBJS) codeclib.o resample.o codec.o ssrc.o call.o ice.o aux.o \
	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
	control_ng.strhash.o \
	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o websocket.o \
	cli.o

test-resample:	test-resample.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-payload-tracker: test-payload-tracker.o $(COMMONOBJS) ssrc.o aux.o auxlib.o rtp.o crypto.o codeclib.o \
	resample.o dtmflib.o

test-kernel-module: test-kernel-module.o $(COMMONOBJS) kernel.o

test-const_str_hash.strhash: test-const_str_hash.strhash.o $(COMMONOBJS)

PRELOAD_CFLAGS += -D_GNU_SOURCE -std=c99
PRELOAD_LIBS += -ldl

tests-preload.so:	tests-preload.c
	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(LDFLAGS) $(PRELOAD_LIBS)

spandsp_send_fax_pcm.c:	spandsp_logging.h
spandsp_send_fax_t38.c:	spandsp_logging.h
spandsp_recv_fax_t38.c:	spandsp_logging.h
spandsp_recv_fax_pcm.c:	spandsp_logging.h

=== debian/changelog ===
rtpengine (10.5.3.5-1) unstable; urgency=medium

  [ Victor Seva ]
  * New upstream version 10.5.3.5
  * wrap-and-sort -sa

  [ Michael Prokop ]
  * Either depend on lsb-base or sysvinit-utils

 -- Victor Seva <vseva@debian.org>  Wed, 22 Feb 2023 11:15:26 +0100

rtpengine (10.5.3.3-2) unstable; urgency=medium

  * [c6252ce] Switch to usage with dh-sequence-dkms. Thanks to
    Andreas Beckmann <anbe@debian.org> for bug report and initial patch
    (Closes: #1030227)

 -- Michael Prokop <mika@debian.org>  Fri, 10 Feb 2023 17:58:58 +0100

rtpengine (10.5.3.3-1) unstable; urgency=medium

  * New upstream version 10.5.3.3

 -- Victor Seva <vseva@debian.org>  Tue, 31 Jan 2023 08:32:14 +0100

rtpengine (10.5.3.1-1) unstable; urgency=medium

  * New upstream version 10.5.3.1
  * pre-depends on adduser was missing

 -- Victor Seva <vseva@debian.org>  Thu, 12 Jan 2023 12:11:15 +0100

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  default-libmysqlclient-dev,
+ dh-sequence-dkms,
  gperf,
  libavcodec-dev (>= 6:10),
  libavfilter-dev (>= 6:10),
@@ -48,15 +49,17 @@
  python3,
  python3-websockets,
  zlib1g-dev,
+Testsuite: autopkgtest-pkg-dkms
 
 Package: rtpengine-daemon
 Architecture: any
 Multi-Arch: foreign
 Pre-Depends:
+ adduser,
  ${misc:Pre-Depends},
 Depends:
  iptables,
- lsb-base (>= 3.0-6),
+ sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
@@ -79,9 +82,9 @@
 Pre-Depends:
  ${misc:Pre-Depends},
 Depends:
- lsb-base (>= 3.0-6),
  nfs-common,
  rtpengine-daemon,
+ sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
@@ -135,8 +138,7 @@
 Section: kernel
 Architecture: all
 Depends:
- dkms (>= 1.95),
- lsb-release,
+ sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
  ${misc:Depends},
 Conflicts:
  ngcp-rtpengine-kernel-dkms,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export XTABLES_DIR := $(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)

ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.no-transcoding))
export with_transcoding = no
endif
ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.asan))
export DO_ASAN_FLAGS = 1
# this prevents dh from setting default (including -O2) which we don't want
export DEB_CFLAGS_MAINT_SET =
export DEB_LDFLAGS_MAINT_SET =
endif

%:
	dh $@

execute_before_dh_auto_install-indep:
	# markdown README
	markdown README.md | gzip -9n > debian/README.html.gz
	gzip -9n < README.md > debian/README.md.gz

execute_after_dh_installsystemd:
	dh_installsystemd -prtpengine-recording-daemon --name=rtpengine-recording-nfs-mount

override_dh_dkms:
	dh_dkms -V $(DEB_VERSION_UPSTREAM)

=== debian/watch ===
version=4
# follow just the mr10.5 line for now
https://github.com/sipwise/rtpengine/tags (?:.*?/)?mr(10\.5[\d.]*)\.tar\.gz

## rtpengine 10.5.5.2

=== debian/changelog ===
rtpengine (10.5.5.2-1) unstable; urgency=medium

  * New upstream version 10.5.5.2 (Closes: #1042407)
  * Vcs-* fields pointing to pkg-voip-team repository

 -- Victor Seva <vseva@debian.org>  Wed, 09 Aug 2023 14:38:52 +0200

rtpengine (10.5.4.3-1) unstable; urgency=medium

  * New upstream version 10.5.4.3
  * update Standards-Version to 4.6.2, no changes needed
  * remove lsb-base | sysvinit-utils dependencies

 -- Victor Seva <vseva@debian.org>  Mon, 01 May 2023 18:45:29 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,9 @@
  Guillem Jover <gjover@sipwise.com>,
  Michael Prokop <mika@debian.org>,
 Homepage: https://github.com/sipwise/rtpengine/
-Standards-Version: 4.6.1
+Vcs-Git: https://salsa.debian.org/pkg-voip-team/rtpengine.git
+Vcs-Browser: https://salsa.debian.org/pkg-voip-team/rtpengine/
+Standards-Version: 4.6.2
 Build-Depends:
  debhelper-compat (= 13),
  default-libmysqlclient-dev,
@@ -59,7 +61,6 @@
  ${misc:Pre-Depends},
 Depends:
  iptables,
- sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
@@ -84,7 +85,6 @@
 Depends:
  nfs-common,
  rtpengine-daemon,
- sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
@@ -138,7 +138,6 @@
 Section: kernel
 Architecture: all
 Depends:
- sysvinit-utils (>= 3.05-4~) | lsb-base (>= 3.0-6),
  ${misc:Depends},
 Conflicts:
  ngcp-rtpengine-kernel-dkms,
